import json
import threading


def subtract(a, b):
    return [*(item for item in a if item not in b)]


def union_two(a, b):
    (m, n) = (len(a), len(b))
    i = j = 0

    # Destination Array
    d = []

    # Merge from a and b together
    while i < m and j < n:
        if a[i] <= b[j]:
            d.append(a[i])
            i += 1
        else:
            d.append(b[j])
            j += 1

    # Merge from a if b has run out
    while i < m:
        d.append(a[i])
        i += 1

    # Merge from b if a has run out
    while j < n:
        d.append(b[j])
        j += 1

    return d


def normalize_list(lst):
    if type(lst) == dict:
        return list(lst.values())
    elif type(lst) == list:
        return lst


def union(inp):
    n = len(inp)
    vl = normalize_list(inp)
    while n >= 2:
        if n == 2:
            vl = union_two(vl[0], vl[1])
        elif n > 2:
            tmp = list()
            tmp.append(vl[n - 1])
            vl = union(vl[0: n - 2])
            tmp.append(vl)
            vl = tmp
        n = n - 1
    return vl


def intersect(lst1, lst2):
    return list(set(lst1) & set(lst2))


def operations(inp):
    flag = []
    if "AND" in inp:
        flag.append("&")
    elif "NOT" in inp:
        flag.append("!")
    return flag


# Get dictionary of docIDs and return the title of most relevant.
def get_info(inp):
    result = list()
    if type(inp) == dict:
        key_list = inp.keys()
        for word in key_list:
            for docID in inp.get(word):
                result.append(docID)
    elif type(inp) == list:
        result = inp

    # Reading docs from docs dictionary.
    out = list()
    for docID in result:
        file = open(f"./docs/{docID}.json", "r", encoding="utf-8")
        cnt = json.load(file)
        cnt = dict(cnt)
        val = cnt.values()
        out.append(list(val))
        file.close()

    return out


def write_logs(string):
    file = open(f"./logs/log.txt", "a", encoding="utf-8")
    file.write(string + "\n")
    file.close()


def enter(it):
    t1 = threading.Thread(target=write_logs, args=(it,))
    t1.start()
    spl = list(it.split(" "))
    file = open("./index/ii.json", "r", encoding="utf-8")
    index = json.load(file)
    dictionary = dict(index)
    rs = []
    for word in spl:
        if word in dictionary.keys():
            rs.append(word)

    ld = dict()
    for i in range(len(rs)):
        ld[rs[i]] = index.get(rs[i])
        print(ld[rs[i]])

    ld_copy = ld.copy()
    opt = list()
    if len(rs) > 1:
        flag = operations(spl)
        while len(flag) > 0:
            if "&" in flag:
                _and = spl.index("AND")
                nxt_word = spl[_and + 1]
                prv_word = spl[_and - 1]
                opt.extend(intersect(ld[nxt_word], ld[prv_word]))
                spl.pop(_and)
                ld.pop(nxt_word)
                ld.pop(prv_word)
                ld["opt"] = opt
                flag = operations(spl)
            elif "!" in flag:
                _not = spl.index("NOT")
                nxt_word = spl[_not + 1]
                prv_word = spl[_not - 1]
                opt = subtract(ld[prv_word], ld[nxt_word])
                print(opt)
                spl.pop(_not)
                flag = operations(spl)

    out_data = get_info(ld)
    t1.join()
    return out_data
