import json
import os

from parsivar import Normalizer, Tokenizer, FindStems

global stop_words


def debugger(string):
    string = string.replace("\'", "\"")
    string = string.replace("\"\"\"", "\"\"")
    string = string.replace("\\", " ")
    string = string.replace("\u200c", " ")
    return string


def normalize(tokens):
    if type(tokens) != list:
        tokens = list(tokens)
    for word in tokens:
        if word in stop_words:
            while word in tokens:
                tokens.remove(word)
    return tokens


def token_maker(filename):
    filepath = os.path.join("./docs", filename)
    file = open(filepath, "r")
    obj = json.load(file)
    obj_cnt = ''
    lst = list()
    for ch in obj["content"]:
        lst.append(ch)
        obj_cnt = ''.join(lst)
    normalizer = Normalizer()
    pars_tokenizer = Tokenizer()
    my_stemmer = FindStems()
    normal_txt = normalizer.normalize(obj_cnt)
    tokens = pars_tokenizer.tokenize_words(normal_txt)
    output = dict()
    index = 0
    tokens = normalize(tokens)

    for word in tokens:
        word = my_stemmer.convert_to_stem(word)
        if word not in output.keys():
            output[str(word)] = [index]
        else:
            indexes = output[word]
            indexes.append(index)
        index = index + 1

    filename = str(filename)
    tk_fl = open(f"document tokens/{filename}", "w", encoding="utf-8")
    str_out = str(output)
    str_out = debugger(str_out)
    tk_fl.write(str_out)


def __starter(upper_bound, files):
    counter = 0
    pre_percent = 0
    print("0% is tokenized!")
    for f in files:
        new_percent = int((counter / upper_bound) * 100)
        token_maker(str(f))
        if new_percent != pre_percent:
            print(f"{new_percent}% is tokenized!")
            pre_percent = new_percent
        counter = counter + 1


def get_file_test(files):
    __starter(23, files)


def get_file(files):
    __starter(12201, files)
